"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var assign = require("lodash/assign");
var React = require("react");
var utils = require("../../utils");
var Input_1 = require("../Input");
var Textarea_1 = require("../Textarea");
exports.operators = {
    is: {
        getLabel: function (_s) { return 'is'; },
    },
    contains: {
        getLabel: function (_s) { return 'contains'; },
    },
    not_contains: {
        getLabel: function (_s) { return 'does not contain'; },
    },
    matches_re: {
        getLabel: function (_s) { return 'matches RegEx'; },
    },
    not_matches_re: {
        getLabel: function (_s) { return 'does not match RegEx'; },
    },
};
exports.decodeFilter = function (filter) {
    var operator = filter.title;
    if (!filter.properties) {
        return null;
    }
    var keys = Object.keys(filter.properties);
    if (!keys.length) {
        return null;
    }
    var value;
    var field = keys[0];
    if (operator === 'is') {
        value = filter.properties[field].const;
    }
    else if (operator === 'contains' || operator === 'not_contains') {
        value = filter.properties[field].description;
    }
    else if (operator === 'matches_re') {
        value = filter.properties[field].pattern;
    }
    else if (operator === 'not_matches_re') {
        value = filter.properties[field].not.pattern;
    }
    else {
        return null;
    }
    return {
        field: field,
        operator: operator,
        value: value,
    };
};
exports.createFilter = function (field, operator, value, schema) {
    var title = schema.title;
    var base = {
        $id: utils.randomString(),
        title: operator,
        description: (title || field) + " " + exports.operators[operator].getLabel(schema) + " " + value,
        type: 'object',
    };
    if (operator === 'is') {
        return assign(base, {
            properties: (_a = {},
                _a[field] = {
                    title: title,
                    const: value,
                },
                _a),
        });
    }
    if (operator === 'contains') {
        return assign(base, {
            properties: (_b = {},
                _b[field] = {
                    type: 'string',
                    description: value,
                    pattern: utils.regexEscape(value),
                },
                _b),
        });
    }
    if (operator === 'not_contains') {
        return assign(base, {
            properties: (_c = {},
                _c[field] = {
                    type: 'string',
                    description: value,
                    not: {
                        pattern: utils.regexEscape(value),
                    },
                },
                _c),
        });
    }
    if (operator === 'matches_re') {
        return assign(base, {
            properties: (_d = {},
                _d[field] = {
                    type: 'string',
                    pattern: value,
                },
                _d),
        });
    }
    if (operator === 'not_matches_re') {
        return assign(base, {
            properties: (_e = {},
                _e[field] = {
                    type: 'string',
                    not: {
                        pattern: value,
                    },
                },
                _e),
        });
    }
    return base;
    var _a, _b, _c, _d, _e;
};
exports.Edit = function (_a) {
    var onUpdate = _a.onUpdate, slim = _a.slim, props = __rest(_a, ["onUpdate", "slim"]);
    if (slim) {
        return (React.createElement(Input_1.default, __assign({ onChange: function (e) {
                return onUpdate(e.currentTarget.value);
            } }, props)));
    }
    return (React.createElement(Textarea_1.default, __assign({ onChange: function (e) {
            return onUpdate(e.currentTarget.value);
        } }, props)));
};
