"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var cloneDeep = require("lodash/cloneDeep");
var findIndex = require("lodash/findIndex");
var isEqual = require("lodash/isEqual");
var map = require("lodash/map");
var reject = require("lodash/reject");
var React = require("react");
var fa_1 = require("react-icons/lib/fa");
var styled_components_1 = require("styled-components");
var theme_1 = require("../../theme");
var utils = require("../../utils");
var Button_1 = require("../Button");
var DataTypes_1 = require("../DataTypes");
var DeleteButton_1 = require("../DeleteButton");
var Grid_1 = require("../Grid");
var Modal_1 = require("../Modal");
var Select_1 = require("../Select");
var Txt_1 = require("../Txt");
var SchemaSieve = require("./SchemaSieve");
var Summary_1 = require("./Summary");
var ViewsMenu_1 = require("./ViewsMenu");
var FilterInput = function (props) {
    var model = DataTypes_1.getDataModel(props.schema);
    if (!model) {
        return null;
    }
    return (React.createElement(model.Edit, { schema: props.schema, value: props.value, operator: props.operator, onUpdate: props.onUpdate, slim: true }));
};
var RelativeBox = styled_components_1.default(Grid_1.Box)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tposition: relative;\n"], ["\n\tposition: relative;\n"])));
var ExtraRuleDeleteBtn = styled_components_1.default(DeleteButton_1.default)(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n\tposition: absolute;\n\tbottom: 7px;\n\tright: -35px;\n"], ["\n\tposition: absolute;\n\tbottom: 7px;\n\tright: -35px;\n"])));
var SimpleSearchBox = styled_components_1.default.div(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n\tposition: relative;\n\tflex-basis: 500px;\n\tborder-bottom: 2px solid ", ";\n\tpadding-left: 20px;\n\tpadding-top: 3px;\n\tmargin-left: 30px;\n\tmargin-right: 30px;\n\n\t.search-icon {\n\t\tposition: absolute;\n\t\ttop: 7px;\n\t\tleft: 0;\n\t\tcolor: ", ";\n\t}\n\n\tinput {\n\t\tbackground: transparent;\n\t\tbox-shadow: none;\n\t\tborder: none;\n\t\twidth: 100%;\n\t\tfont-size: inherit;\n\t\tpadding: 5px;\n\t\t::placeholder {\n\t\t\tfont-style: italic;\n\t\t\tcolor: ", ";\n\t\t}\n\t}\n"], ["\n\tposition: relative;\n\tflex-basis: 500px;\n\tborder-bottom: 2px solid ", ";\n\tpadding-left: 20px;\n\tpadding-top: 3px;\n\tmargin-left: 30px;\n\tmargin-right: 30px;\n\n\t.search-icon {\n\t\tposition: absolute;\n\t\ttop: 7px;\n\t\tleft: 0;\n\t\tcolor: ", ";\n\t}\n\n\tinput {\n\t\tbackground: transparent;\n\t\tbox-shadow: none;\n\t\tborder: none;\n\t\twidth: 100%;\n\t\tfont-size: inherit;\n\t\tpadding: 5px;\n\t\t::placeholder {\n\t\t\tfont-style: italic;\n\t\t\tcolor: ", ";\n\t\t}\n\t}\n"])), theme_1.default.colors.gray.main, theme_1.default.colors.gray.main, theme_1.default.colors.gray.main);
var FilterWrapper = styled_components_1.default(Grid_1.Box)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n\tposition: relative;\n"], ["\n\tposition: relative;\n"])));
var Filters = (function (_super) {
    __extends(Filters, _super);
    function Filters(props) {
        var _this = _super.call(this, props) || this;
        var _a = _this.props, filters = _a.filters, schema = _a.schema, views = _a.views;
        var flatSchema = SchemaSieve.flattenSchema(schema);
        _this.state = {
            showModal: false,
            searchString: '',
            editingFilter: null,
            filters: filters || [],
            views: views || [],
            schema: flatSchema,
            edit: [],
        };
        _this.state.edit.push(_this.getCleanEditModel());
        return _this;
    }
    Filters.prototype.componentWillReceiveProps = function (prevProps) {
        if (!isEqual(prevProps.schema, this.props.schema)) {
            this.setState({
                schema: SchemaSieve.flattenSchema(this.props.schema),
            });
        }
    };
    Filters.prototype.getCleanEditModel = function (field) {
        var schema = this.state.schema;
        if (!field) {
            field = Object.keys(schema.properties).shift();
        }
        var operator = this.getOperators(field).shift().slug;
        return {
            field: field,
            operator: operator,
            value: '',
        };
    };
    Filters.prototype.getOperators = function (field) {
        var schema = this.state.schema;
        return SchemaSieve.getOperators(schema, field);
    };
    Filters.prototype.setEditField = function (field, index) {
        var currentEdit = this.state.edit.slice();
        currentEdit.splice(index, 1, this.getCleanEditModel(field));
        this.setState({
            edit: currentEdit,
        });
    };
    Filters.prototype.setEditOperator = function (operator, index) {
        var currentEdit = this.state.edit.slice();
        var item = currentEdit[index];
        currentEdit.splice(index, 1, __assign({}, item, { operator: operator }));
        this.setState({
            edit: currentEdit,
        });
    };
    Filters.prototype.setEditValue = function (value, index) {
        var currentEdit = this.state.edit.slice();
        var item = currentEdit[index];
        currentEdit.splice(index, 1, __assign({}, item, { value: value }));
        this.setState({
            edit: currentEdit,
        });
    };
    Filters.prototype.emitFilterUpdate = function () {
        if (!this.props.onFiltersUpdate) {
            return;
        }
        this.props.onFiltersUpdate(this.state.filters.map(function (filter) { return SchemaSieve.unflattenSchema(filter); }));
    };
    Filters.prototype.addFilter = function () {
        var _this = this;
        var $id = this.state.editingFilter;
        var schema = this.state.schema;
        var filter = SchemaSieve.createFilter(schema, this.state.edit);
        var currentFilters = this.state.filters;
        var filters;
        if (!!$id) {
            var matchIndex = findIndex(currentFilters, { $id: $id });
            currentFilters.splice(matchIndex, 1, filter);
            filters = currentFilters.slice();
        }
        else {
            filters = currentFilters.concat(filter);
        }
        this.setState({
            filters: filters,
            edit: [this.getCleanEditModel()],
            showModal: false,
            editingFilter: null,
        }, function () { return _this.emitFilterUpdate(); });
    };
    Filters.prototype.editFilter = function (filter) {
        var schema = this.state.schema;
        var signatures = SchemaSieve.decodeFilter(schema, filter);
        this.setState({
            edit: signatures,
            editingFilter: filter.$id,
            showModal: true,
        });
    };
    Filters.prototype.removeFilter = function (_a) {
        var _this = this;
        var $id = _a.$id;
        this.setState(function (prevState) { return ({
            filters: reject(prevState.filters, { $id: $id }),
        }); }, function () { return _this.emitFilterUpdate(); });
    };
    Filters.prototype.setFilters = function (filters) {
        var _this = this;
        this.setState({ filters: filters }, function () { return _this.emitFilterUpdate(); });
    };
    Filters.prototype.addCompound = function () {
        var _this = this;
        this.setState(function (prevState) { return ({
            edit: prevState.edit.concat(_this.getCleanEditModel()),
        }); });
    };
    Filters.prototype.removeCompound = function (index) {
        var edit = this.state.edit.slice();
        edit.splice(index, 1);
        this.setState({
            edit: edit,
        });
    };
    Filters.prototype.saveView = function (name, scope) {
        var _this = this;
        var view = {
            id: utils.randomString(),
            name: name,
            scope: scope,
            filters: cloneDeep(this.state.filters),
        };
        this.setState(function (prevState) { return ({
            views: prevState.views.concat(view),
        }); }, function () {
            return _this.props.onViewsUpdate && _this.props.onViewsUpdate(_this.state.views);
        });
    };
    Filters.prototype.deleteView = function (_a) {
        var _this = this;
        var id = _a.id;
        this.setState(function (prevState) { return ({
            views: reject(prevState.views, { id: id }),
        }); }, function () {
            return _this.props.onViewsUpdate && _this.props.onViewsUpdate(_this.state.views);
        });
    };
    Filters.prototype.setSimpleSearch = function (term) {
        var _this = this;
        this.setState(function (prevState) {
            var newFilters = term
                ? SchemaSieve.upsertFullTextSearch(_this.state.schema, prevState.filters, term)
                : SchemaSieve.removeFullTextSearch(prevState.filters);
            return {
                searchString: term,
                filters: newFilters,
            };
        }, function () { return _this.emitFilterUpdate(); });
    };
    Filters.prototype.render = function () {
        var _this = this;
        var filters = this.state.filters;
        return (React.createElement(FilterWrapper, { mb: 3 },
            React.createElement(Grid_1.Flex, { justify: "space-between" },
                React.createElement(Button_1.default, __assign({ disabled: this.props.disabled, primary: true, onClick: function () {
                        return _this.setState({ showModal: true, editingFilter: null });
                    } }, this.props.addFilterButtonProps),
                    React.createElement(fa_1.FaFilter, { style: { marginRight: 10 } }),
                    "Add filter"),
                React.createElement(SimpleSearchBox, null,
                    React.createElement("input", { style: { color: this.props.dark ? '#fff' : undefined }, disabled: this.props.disabled, placeholder: "Search entries...", value: this.state.searchString, onChange: function (e) { return _this.setSimpleSearch(e.target.value); } }),
                    React.createElement(fa_1.FaSearch, { className: "search-icon", name: "search" })),
                React.createElement(ViewsMenu_1.default, { buttonProps: this.props.viewsMenuButtonProps, disabled: this.props.disabled, views: this.state.views || [], schema: this.state.schema, setFilters: function (filters) { return _this.setFilters(filters); }, deleteView: function (view) { return _this.deleteView(view); } })),
            this.state.showModal && (React.createElement("div", null,
                React.createElement(Modal_1.default, { title: "Filter by", cancel: function () { return _this.setState({ showModal: false }); }, done: function () { return _this.addFilter(); }, action: "Save" },
                    map(this.state.edit, function (_a, index) {
                        var field = _a.field, operator = _a.operator, value = _a.value;
                        var operators = _this.getOperators(field);
                        return (React.createElement(RelativeBox, { key: index },
                            index > 0 && React.createElement(Txt_1.default, { my: 2 }, "OR"),
                            React.createElement(Grid_1.Flex, null,
                                React.createElement(Select_1.default, { value: field, onChange: function (v) {
                                        return _this.setEditField(v.target.value, index);
                                    } }, map(_this.state.schema.properties, function (s, field) { return (React.createElement("option", { key: field, value: field }, s.title || field)); })),
                                operators.length === 1 && (React.createElement(Txt_1.default, { mx: 1, p: "7px 20px 0" }, operators[0].label)),
                                operators.length > 1 && (React.createElement(Select_1.default, { ml: 1, value: operator, onChange: function (v) {
                                        return _this.setEditOperator(v.target.value, index);
                                    } }, map(operators, function (_a) {
                                    var slug = _a.slug, label = _a.label;
                                    return (React.createElement("option", { key: slug, value: slug }, label));
                                }))),
                                React.createElement(FilterInput, { operator: operator, value: value, schema: _this.state.schema.properties[field], onUpdate: function (v) { return _this.setEditValue(v, index); } })),
                            index > 0 && (React.createElement(ExtraRuleDeleteBtn, { onClick: function () { return _this.removeCompound(index); } }))));
                    }),
                    React.createElement(Button_1.default, { mb: 2, mt: 4, primary: true, underline: true, onClick: function () { return _this.addCompound(); } }, "Add alternative")))),
            !!filters.length &&
                !this.props.disabled && (React.createElement(Summary_1.default, { edit: function (filter) { return _this.editFilter(filter); }, delete: function (filter) { return _this.removeFilter(filter); }, saveView: function (name, scope) { return _this.saveView(name, scope); }, filters: filters, views: this.state.views || [], schema: this.state.schema, dark: !!this.props.dark }))));
    };
    return Filters;
}(React.Component));
exports.default = Filters;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4;
