"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_1 = require("@storybook/react");
var _1 = require("../");
react_1.storiesOf('Tooltip', module)
    .addDecorator(function (story) { return React.createElement(_1.Box, { m: 4 }, story()); })
    .addWithInfo('Standard', function () {
    return (React.createElement(_1.Box, null,
        React.createElement(_1.Button, { tooltip: 'Tooltip on top', m: 2, primary: true, onPress: react_1.action('case-1') }, "Tooltip on top"),
        React.createElement(_1.Button, { tooltip: { text: 'Tooltip on right', placement: 'right' }, m: 2, secondary: true, onPress: react_1.action('case-2') }, "Tooltip on right"),
        React.createElement(_1.Button, { tooltip: { text: 'Tooltip on bottom', placement: 'bottom' }, m: 2, success: true, onPress: react_1.action('case-3') }, "Tooltip on bottom"),
        React.createElement(_1.Button, { tooltip: { text: 'Tooltip on left', placement: 'left' }, m: 2, tertiary: true, onPress: react_1.action('case-4') }, "Tooltip on left")));
})
    .addWithInfo('Click', function () {
    return (React.createElement(_1.Box, null,
        React.createElement(_1.Button, { tooltip: { text: 'Tooltip on top', trigger: 'click' }, m: 2, primary: true, onPress: react_1.action('case-1') }, "Tooltip on top"),
        React.createElement(_1.Button, { tooltip: {
                text: 'Tooltip on right',
                trigger: 'click',
                placement: 'right'
            }, m: 2, secondary: true, onPress: react_1.action('case-2') }, "Tooltip on right"),
        React.createElement(_1.Button, { tooltip: {
                text: 'Tooltip on bottom',
                trigger: 'click',
                placement: 'bottom'
            }, m: 2, success: true, onPress: react_1.action('case-3') }, "Tooltip on bottom"),
        React.createElement(_1.Button, { tooltip: {
                text: 'Tooltip on left',
                trigger: 'click',
                placement: 'left'
            }, m: 2, tertiary: true, onPress: react_1.action('case-4') }, "Tooltip on left")));
})
    .addWithInfo('Supported Elements', function () {
    return (React.createElement(_1.Box, null,
        React.createElement(_1.Heading.h3, null, "Alert"),
        React.createElement(_1.Alert, { tooltip: 'Alert tooltip', warning: true }, "Lorem ipsum dolor sit amet."),
        React.createElement(_1.Heading.h3, { mt: 30 }, "Badge"),
        React.createElement(_1.Badge, { tooltip: 'Badge tooltip', text: 'lorem' }),
        React.createElement(_1.Heading.h3, { mt: 30 }, "BadgeSelect"),
        React.createElement(_1.BadgeSelect, { tooltip: 'BadgeSelect tooltip', items: ['wpe', 'web', 'redis'] }),
        React.createElement(_1.Heading.h3, { mt: 30 }, "Box"),
        React.createElement(_1.Box, { tooltip: 'Box tooltip' }, "Lorem ipsum dolor sit amet."),
        React.createElement(_1.Heading.h3, { mt: 30 }, "Button"),
        React.createElement(_1.Button, { tooltip: 'Button tooltip' }, "Lorem ipsum"),
        React.createElement(_1.Heading.h3, { mt: 30 }, "CodeWithCopy"),
        React.createElement(_1.CodeWithCopy, { text: 'Lorem', tooltip: 'CodeWithCopy tooltip' }),
        React.createElement(_1.Heading.h3, { mt: 30 }, "DeleteButton"),
        React.createElement(_1.DeleteButton, { tooltip: 'DeleteButton tooltip' }),
        React.createElement(_1.Heading.h3, { mt: 30 }, "DropDownButton"),
        React.createElement(_1.DropDownButton, { tooltip: 'DropDownButton tooltip', mx: 2, primary: true, label: React.createElement("div", null, "DropDown") },
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item"),
            React.createElement("div", null, "Item")),
        React.createElement(_1.Fixed, { right: '30px', tooltip: 'Fixed tooltip' },
            React.createElement(_1.Heading.h3, { mt: 30 }, "Fixed")),
        React.createElement(_1.Heading.h3, { mt: 30 }, "Flex"),
        React.createElement(_1.Flex, { style: { height: 30 }, bg: 'red', tooltip: 'Flex tooltip' }),
        React.createElement(_1.Heading.h3, { mt: 30 }, "Heading"),
        React.createElement(_1.Heading.h2, { tooltip: 'Heading tooltip' }, "Hello world!"),
        React.createElement(_1.Heading.h3, { mt: 30 }, "Link"),
        React.createElement(_1.Link, { tooltip: 'Link tooltip' }, "Lorem ipsum dolor sit amet"),
        React.createElement(_1.Heading.h3, { mt: 30 }, "Txt"),
        React.createElement(_1.Txt, { tooltip: 'Txt tooltip' }, "Lorem ipsum dolor sit amet")));
})
    .addWithInfo('Elements', function () {
    return (React.createElement(_1.Box, null,
        React.createElement(_1.Heading.h3, null, "Alert"),
        React.createElement(_1.Alert, { tooltip: 'Alert tooltip', warning: true }, "Lorem ipsum dolor sit amet."),
        React.createElement(_1.Heading.h3, { mt: 30 }, "Badge"),
        React.createElement(_1.Badge, { tooltip: 'Badge tooltip', text: 'lorem' }),
        React.createElement(_1.Heading.h3, { mt: 30 }, "BadgeSelect"),
        React.createElement(_1.BadgeSelect, { tooltip: 'BadgeSelect tooltip', items: ['wpe', 'web', 'redis'] }),
        React.createElement(_1.Heading.h3, { mt: 30 }, "Box"),
        React.createElement(_1.Box, { tooltip: 'Box tooltip' }, "Lorem ipsum dolor sit amet."),
        React.createElement(_1.Heading.h3, { mt: 30 }, "Button"),
        React.createElement(_1.Button, { tooltip: 'Button tooltip' }, "Lorem ipsum"),
        React.createElement(_1.Heading.h3, { mt: 30 }, "CodeWithCopy"),
        React.createElement(_1.CodeWithCopy, { text: 'Lorem', tooltip: 'CodeWithCopy tooltip' }),
        React.createElement(_1.Heading.h3, { mt: 30 }, "DeleteButton"),
        React.createElement(_1.DeleteButton, { tooltip: 'DeleteButton tooltip' })));
});
